<template>
  <h1>Kittens</h1>

  <DataTable :value="kittens" responsiveLayout="scroll">
    <Column field="name" header="Name"></Column>
    <Column field="gender" header="Gender"> 
      <template #body="slotProps">
        <div>
          {{slotProps.data.gender == 0 ? '&#9794;' : '&#9792;'}}
        </div>
      </template></Column>
    <Column field="age" header="Age"></Column>
    <Column field="color" header="Color"></Column>
    <Column field="actions" header="Actions">
      <template #body="slotProps">
        <Button @click="deleteKitten(slotProps.data.id)" label="X" class="p-button-danger"/>
      </template>
    </Column>
  </DataTable>

<CreateKittenForm v-if="isCreatingKitten" @requestToggleDisplay="toggleKittenCreation"/>
<Button v-else @click="toggleKittenCreation" label="+" class="p-button-success"/>
</template>

<script>
// @ is an alias to /src
import KittenDisplay from '@/components/KittenDisplay.vue';
import CreateKittenForm from '@/components/CreateKittenForm.vue';

import { API } from 'aws-amplify';
import { listKittens } from '@/graphql/queries';
import { deleteKitten } from '../graphql/mutations';
import { onCreateKitten, onDeleteKitten } from '@/graphql/subscriptions';

export default {
  name: 'KittenView',
  async created() {
    this.getKittens();
    this.subscribe();
  },
  data() {
    return {
      kittens: [],
      isCreatingKitten: false,
    }
  },
  components: {
    KittenDisplay,
    CreateKittenForm,
  },
  methods: {
    // observation des modifications
    subscribe() {
      API.graphql({ query: onCreateKitten })
        .subscribe({
          next: (eventData) => {
            let createdKitten = eventData.value.data.onCreateKitten;
            if (this.kittens.some(item => item.id === createdKitten.id)) return;
            this.kittens = [...this.kittens, createdKitten];
          }
        });
      API.graphql({ query: onDeleteKitten })
        .subscribe({
          next: (eventData) => {
            let deletedKitten = eventData.value.data.onDeleteKitten;
            this.kittens = this.kittens.filter(item => item.id !== deletedKitten.id);
          }
        });
    },
    toggleKittenCreation() {
      this.isCreatingKitten = !this.isCreatingKitten;
    },
    async getKittens() {
      const kittens = await API.graphql({
        query: listKittens
      });
      this.kittens = kittens.data.listKittens.items;
    },
    async deleteKitten(kittenId){
      await API.graphql({
        query: deleteKitten,
        variables: { input: {id: kittenId} }
      });
    },
  }
}
</script>